discussion/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path

#import the views.py from the same folder
from . import views

app_name = 'todolist'

urlpatterns = [
	path('index', views.index, name = 'index'),
	path('<int:todoitem_id>/', views.todoitem, name = "viewtodoitem"),
	path('register', views.register, name = "register"),
	path('change_password', views.change_password, name = "change_password"),
	path('login', views.login_user, name = "login"),
	path('logout', views.logout_user, name = "logout"),
	path('add_task', views.add_task, name = "add_task"),
	path('<int:eventitem_id>/', views.eventitem, name = "vieweventitem"),
	path('add_event', views.add_event, name = "add_event"),
	path('<int:eventitem_id>/update_event', views.update_event, name = "update_event"),
	path('<int:eventitem_id>/delete_event', views.delete_event, name = "delete_event"),
	path('<int:todoitem_id>/update_task', views.update_task, name="update_task"),
	path('<int:todoitem_id>/delete', views.delete_task, name = "delete_task")
]

todolist/models.py
from django.db import models

# Create your models here.
from django.contrib.auth.models import User

class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default = "pending")
	date_created =  models.DateTimeField('date created')
	user = models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

class EventItem(models.Model):
    name = models.CharField(max_length=100)
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default = "pending")
    event_date = models.DateTimeField('Event Date')
    user = models.ForeignKey(User, on_delete=models.CASCADE)

todolist/forms.py
from django import forms
from django.contrib.auth.models import User

class LoginForm(forms.Form):
	username = forms.CharField(label = "username", max_length = 20)
	password = forms.CharField(label = "password", max_length = 20)

class AddTaskForm(forms.Form):
	task_name =  forms.CharField(label = "task_name", max_length = 50)
	description =  forms.CharField(label = "description", max_length = 200)

class UpdateTaskForm(forms.Form):
	task_name = forms.CharField(label = "task_name", max_length = 50)
	description = forms.CharField(label = "description", max_length = 200)
	status = forms.CharField(label = "status", max_length = 50)

class RegistrationForm(forms.Form):
    username = forms.CharField(label='Username', max_length=20, widget=forms.TextInput(attrs={'class': 'form-control'}))
    first_name = forms.CharField(label='First Name', max_length=30, widget=forms.TextInput(attrs={'class': 'form-control'}))
    last_name = forms.CharField(label='Last Name', max_length=30, widget=forms.TextInput(attrs={'class': 'form-control'}))
    email = forms.EmailField(label='Email', max_length=254, widget=forms.EmailInput(attrs={'class': 'form-control'}))
    password1 = forms.CharField(label='Password', widget=forms.PasswordInput(attrs={'class': 'form-control'}))
    password2 = forms.CharField(label='Confirm Password', widget=forms.PasswordInput(attrs={'class': 'form-control'}))


class AddEventForm(forms.Form):
    name = forms.CharField(label = "name",max_length=100),
    description = forms.CharField(label = "description",max_length=200)

class UpdateEventForm(forms.Form):
    name = forms.CharField(label = "name",max_length=100),
    description = forms.CharField(label = "description",max_length=200),
    status = forms.CharField(label = "status", max_length = 50)

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.


#The from keyword allows importing of necessary classes/modules, methods and other files needed in our application from the django.http package while the import keyword defines what we are importing from the package
from django.http import HttpResponse

#Local imports
from .models import ToDoItem, EventItem

from django.contrib.auth.models import User

#to use the template created:
from django.template import loader

from django.contrib.auth import authenticate, login, logout

from django.forms.models import model_to_dict

from .forms import LoginForm, AddTaskForm, UpdateTaskForm, RegistrationForm, AddEventForm, UpdateEventForm

from django.utils import timezone

def index(request):
	todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
	eventitem_list = EventItem.objects.filter(user_id = request.user.id)
	template = loader.get_template("index.html")
	context = {
		'todoitem_list': todoitem_list,
		'eventitem_list': eventitem_list,
		"user": request.user
	}
	# output = ", ".join([todoitem.task_name for todoitem in todoitem_list])
	return HttpResponse(template.render(context, request))
	# return HttpResponse("Hello from the views.py file!")

def todoitem(request, todoitem_id):
	# response = f"You are viewing the details of {todoitem_id}"
	# return HttpResponse(response)

	todoitem = get_object_or_404(ToDoItem, pk = todoitem_id)

	return render(request, "todoitem.html", model_to_dict(todoitem))

# def register(request):

	# if request.method == 'POST':

	# 	form = RegistrationForm(request.POST)

	# 	if form.is_valid():
	# 		form.save()
	# 		login(request, user)
	# 		messages.success(request, "Registration successful." )
	# 		return redirect('todolist:login')
	# 	messages.error(request, "Unsuccessful registration. Invalid information.")
	# else: 
	# 	form = RegistrationForm()
	# return render(request=request, template_name='register.html', context={ 'form': form })

def register(request):
    if request.method == 'POST':
        form = RegistrationForm(request.POST)
        if form.is_valid():
            username = form.cleaned_data['username']
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            email = form.cleaned_data['email']
            password1 = form.cleaned_data['password1']
            password2 = form.cleaned_data['password2']

            if password1 == password2:
                # check if the user already exists in the database
                if User.objects.filter(username=username).exists():
                    form.add_error('username', 'This username is already taken.')
                else:
                    user = User.objects.create_user(username=username, first_name=first_name, last_name=last_name, email=email, password=password1)
                    user.is_staff = False
                    user.is_active = True
                    user.save()

                    context = {
                        'is_user_registered': True,
                        'first_name': first_name,
                        'last_name': last_name
                    }
                    return render(request, "login.html", context)
            else:
                form.add_error('password2', 'Passwords do not match.')
    else:
        form = RegistrationForm()

    context = {
        'form': form,
    }
    return render(request, 'register.html', context)

def change_password(request):

	is_user_authenticated = False

	user = authenticate(username= "johndoe", password = "john1234")

	if user is not None:
		authenticated_user = User.objects.get(username = 'johndoe')
		authenticated_user.set_password("johndoe12345")
		authenticated_user.save()

		is_user_authenticated = True

	context = {
		"is_user_authenticated": is_user_authenticated
	}

	return render(request, "change_password.html", context)


def login_user(request):
	context={}

	if request.method == "POST":

		form = LoginForm(request.POST)

		if form.is_valid() == False:
			form = LoginForm()
		else :

			username = form.cleaned_data['username']
			password = form.cleaned_data['password']

			user = authenticate(username = username, password =  password)

			if user is not None:
				context = {
					'username': username,
					'password': password
				}
				login(request, user)
				return redirect("todolist:index")
			else:
				context = {
					'error' : True
				}
			
	return render(request, "login.html", context)


	# username = 'johndoe'
	# password = 'johndoe12345'

	# is_user_authenticated = False

	# user = authenticate(username = username, password = password)

	

def logout_user(request):
	logout(request)
	return redirect("todolist:index")


def add_task(request):
	context = {}

	if request.method == 'POST':
		form = AddTaskForm(request.POST)

		if form.is_valid() == False:
			form = AddTaskForm()
		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']

			duplicates = ToDoItem.objects.filter(task_name = task_name, user_id = request.user.id)

			if not duplicates:

				ToDoItem.objects.create(task_name = task_name, description = description, date_created = timezone.now(), user_id = request.user.id)

				return redirect("todolist:index")

			else:
				context = {
					'error': True
				}
	
	return render(request, "add_task.html", context)

def update_task(request,todoitem_id):

	todoitem = ToDoItem.objects.filter(pk = todoitem_id)

	context = {
		'user': request.user,
		'todoitem_id': todoitem_id,
		'task_name': todoitem[0].task_name,
		'description': todoitem[0].description,
		'status': todoitem[0].status
	}

	if request.method == "POST":
		form = UpdateTaskForm(request.POST)

		if form.is_valid == False:
			form =  UpdateTaskForm()

		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']
			status = form.cleaned_data['status']

			if todoitem:

				todoitem[0].task_name = task_name
				todoitem[0].description = description
				todoitem[0].status = status

				todoitem[0].save()

				return redirect("todolist:viewtodoitem", todoitem_id =  todoitem[0].id)

			else:

				context = {
					'error': True
				}

	return render(request, "update_task.html, context")

def delete_task(request, todoitem_id):

	ToDoItem.objects.filter(pk = todoitem_id).delete()

	return redirect("todolist:index")

def eventitem(request, eventitem_id):
	# response = f"You are viewing the details of {todoitem_id}"
	# return HttpResponse(response)

	eventitem = get_object_or_404(EventItem, pk = eventitem_id)

	return render(request, "eventitem.html", model_to_dict(eventitem))

def add_event(request):
	context = {}

	if request.method == 'POST':
		form = AddEventForm(request.POST)

		if form.is_valid() == False:
			form = AddEventForm()
		else:
			name = form.cleaned_data['name']
			description = form.cleaned_data['description']

			duplicates = EventItem.objects.filter(name = name, user_id = request.user.id)

			if not duplicates:

				EventItem.objects.create(name = name, description = description, event_date = timezone.now(), user_id = request.user.id)

				return redirect("todolist:index")

			else:
				context = {
					'error': True
				}
	
	return render(request, "add_event.html", context)

def update_event(request,eventitem_id):

	eventitem = EventItem.objects.filter(pk = eventitem_id)

	context = {
		'user': request.user,
		'eventitem_id': eventitem_id,
		'name': eventitem[0].name,
		'description': eventitem[0].description,
		'status': eventitem[0].status
	}

	if request.method == "POST":
		form = UpdateEventForm(request.POST)

		if form.is_valid == False:
			form =  UpdateEventForm()

		else:
			name = form.cleaned_data['name']
			description = form.cleaned_data['description']
			status = form.cleaned_data['status']

			if todoitem:

				eventitem[0].name = name
				eventitem[0].description = description
				eventitem[0].status = status

				eventitem[0].save()

				return redirect("todolist:vieweventitem", eventitem_id =  eventitem[0].id)

			else:

				context = {
					'error': True
				}

	return render(request, "update_event.html, context")

def delete_event(request, eventitem_id):

	EventItem.objects.filter(pk = eventitem_id).delete()

	return redirect("todolist:index")

todolist/templates/add_event.html
{% extends 'base.html' %}

{% block title %} Add Event {% endblock %}

{% block content %}
	<div class="conatiner">
		<div class="row">
			<div class= "col-6 offset-3">
				{% if error == True %}
					<p class="text-danger">Duplicate event found!</p>
				{% endif %}

				<form action="{% url 'todolist:add_event' %}" method="POST">

                        {% csrf_token %}

                        <div class="mb-3">
                            <label for="name">Event Name: </label>
                            <input class="form-control" id="name" type="text" name="name" value="{{name}}" maxlength="50" required>
                        </div>

                        <div class="mb-3">
                            <label for="description">Description: </label>
                            <textarea class="form-control" name="description" value="{{description}}" required></textarea>
                        </div>

                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Add Event">
                        </div>

                    </form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/add_task.html
{% extends 'base.html' %}

{% block title %} Add Task {% endblock %}

{% block content %}
	<div class="conatiner">
		<div class="row">
			<div class= "col-6 offset-3">
				{% if error == True %}
					<p class="text-danger">Duplicate task found!</p>
				{% endif %}

				<form action="{% url 'todolist:add_task' %}" method="POST">

                        {% csrf_token %}

                        <div class="mb-3">
                            <label for="task_name">Task Name: </label>
                            <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
                        </div>

                        <div class="mb-3">
                            <label for="description">Description: </label>
                            <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
                        </div>

                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Add Task">
                        </div>

                    </form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/change_password.html
{% if is_user_authenticated == False %}
	<h1>Invalid User Credentials</h1>
	<p>Check if the username and password is correct!</p>

{% else %}
	<h1>User password successfully updated!</h1>
	<p>The password has been successfully updated!</p>

{% endif %}

todolist/templates/eventitem.html
{% extends "base.html" %}

{% block title %}My Tasks{% endblock %}

{% block content %}

	<div class = "text-center mt-3">
		<h1>{{name}}</h1>
		<h3>Description</h3>
		<p>{{description}}</p>
		<h3>Status:</h3>
		<p>{{status}}</p>

		<button class = "btn btn-success mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:update_event' id%}">Edit this event</a>
		</button>

		<button class = "btn btn-danger mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:delete_event' id %}">Delete this event</a>
		</button>

		<button class = "btn btn-warning mx-1">
			<a class= "text-decoration-none"href = "{% url 'todolist:index' %}">Back to index page!</a>
		</button>

	</div>

{% endblock %}

todolist/templates/index.html
{% extends 'base.html' %}

{% block title %}Home{% endblock %}

{% block content %}

    {% if todoitem_list and eventitem_list and user.is_anonymous == False %}
        <h1 class="text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>

        <div class="container">
            <div class="row">
                <h3 class="text-center mb-3">My Tasks</h3>
                <ul class="list-group text-center col-lg-4 offset-lg-4">
                {% for todoitem in todoitem_list %}
                    <li class="list-group-item"><a class="text-decoration-none" href = "{% url 'todolist:viewtodoitem' todoitem.id %}">{{todoitem.task_name}}</a></li>
                {% endfor%} 
                </ul>
            </div>
            <div class="row">
                <h3 class="text-center mb-3">My Events</h3>
                <ul class="list-group text-center col-lg-4 offset-lg-4">
                {% for eventitem in eventitem_list %}
                    <li class="list-group-item"><a class="text-decoration-none" href = "{% url 'todolist:vieweventitem' eventitem.id %}">{{eventitem.name}}</a></li>
                {% endfor%} 
                </ul>
            </div>
        </div>
        
    {% elif todoitem_list.count == 0 or eventitem_list and user.is_anonymous == False %}
    <h1 class="text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>
        <div class="container-fluid">
            <div class="row py-3">
                <h3 class="text-center mb-3">My Tasks</h3>
                <p class="text-center my-3">No tasks have been created.</p>
            </div>
            <div class="row py-3">
                <h3 class="text-center mb-3">My Events</h3>
                <ul class="list-group text-center col-lg-4 offset-lg-4">
                {% for eventitem in eventitem_list %}
                    <li class="list-group-item"><a class="text-decoration-none" href = "{% url 'todolist:vieweventitem' eventitem.id %}">{{eventitem.name}}</a></li>
                {% endfor%} 
                </ul>
            </div>
        </div>
    {% elif todoitem_list or eventitem_list.count == 0 and user.is_anonymous == False %}
    <h1 class="text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>
        <div class="container-fluid">
            <div class="row py-3">
                <h3 class="text-center mb-3">My Tasks</h3>
                <ul class="list-group text-center col-lg-4 offset-lg-4">
                {% for todoitem in todoitem_list %}
                    <li class="list-group-item"><a class="text-decoration-none" href = "{% url 'todolist:viewtodoitem' todoitem.id %}">{{todoitem.task_name}}</a></li>
                {% endfor%} 
                </ul>
            </div>
            <div class="row py-3">
                <h3 class="text-center mb-3">My Events</h3>
                <p class="text-center my-3">No events have been created.</p>
            </div>
        </div>
    {%else%}
        <h1 class="text-center my-3">You are not authorized to access this page.</h1>
        <p class="text-center my-3">Kindly login <a href = "{% url 'todolist:login'%}">here</a>.</p>
    {% endif %}

{% endblock %}



<!-- {% if todoitem_list %}
    <ul>
    {% for todoitem in todoitem_list %}
        <li><a href = "{{todoitem.id}}">{{todoitem.task_name}}</a></li>
    {% endfor%}    
    </ul>
{% else %}
    <p>No tasks have been created.</p>
{% endif %} -->

todolist/templates/login.html
{% extends "base.html" %}

{% block title %}Login{% endblock %}

{% block content%}
	<h1 class="text-center my-3">Login Form</h1>
	<div class = "container">
		<div class="row">
			<div class="col-6 offset-3">

				{% if error == True %}
					<p class="text-danger">Invalid credentials. Please check your username and password or register first.</p>
				{% endif %}
				<form action = "{% url 'todolist:login' %}" method="POST">

					{% csrf_token %}
				<div class="mb-3">
				    <label for="username" class="form-label">Username:</label>
				    <input 
				    	type="username" 
				    	class="form-control" 
				    	id="username"
				    	value = "{{ username }}"
				    	name = "username"
				    	maxlength="20"
				    	required 
				    	>
				  </div>
				  <div class="mb-3">
				    <label for="password" class="form-label">Password:</label>
				    <input 
				    	type="password" 
				    	class="form-control" 
				    	id="password"
				    	value = "{{ password }}"
				    	name = "password"
				    	maxlength="20"
				    	required
				    	>
				  </div>
				  <button type="submit" class="btn btn-primary">Login</button>  
				</form>
			</div>
		</div>
	</div>

{% endblock %}

todolist/templates/register.html
{% extends 'base.html' %}

{% if form.errors %}
<div class="alert alert-danger" role="alert">
    {{ form.non_field_errors }}
    {% if form.username.errors %}
    <p>{{ form.username.errors }}</p>
    {% endif %}
    <!-- add more fields here if needed -->
</div>
{% endif %}

{% block content %}
	<h1 class="text-center my-3">Register</h2>
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3"> 
				<form method="POST">
					{% csrf_token %}

					<div class="mb-3">
						<label for="first_name" class="form-label">First Name:</label>
						<input 
						type="text" 
						class="form-control" 
						id="{{ form.first_name.id_for_label }}"
						name = "{{ form.first_name.name }}"
						placeholder="{{ form.first_name.label }}"
						maxlength="20"
						required 
						>
					</div>

					<div class="mb-3">
						<label for="last_name" class="form-label">Last Name:</label>
						<input 
						type="text" 
						class="form-control" 
						id="{{ form.last_name.id_for_label }}"
						name = "{{ form.last_name.name }}"
						placeholder="{{ form.last_name.label }}"
						maxlength="20"
						required 
						>
					</div>

					<div class="mb-3">
						<label for="email" class="form-label">Email:</label>
						<input 
						type="email" 
						class="form-control" 
						id="{{ form.email.id_for_label }}"
						name = "{{ form.email.name }}"
						placeholder="{{ form.email.label }}"
						maxlength="50"
						required 
						>
					</div>

					<div class="mb-3">
						<label for="username" class="form-label">Username:</label>
						<input 
						type="text" 
						class="form-control" 
						id="{{ form.username.id_for_label }}"
						name = "{{ form.username.name }}"
						placeholder="{{ form.username.label }}"
						maxlength="20"
						required 
						>
					</div>

					<div class="mb-3">
						<label for="password1" class="form-label">Password:</label>
						<input 
						type="password" 
						class="form-control" 
						id="{{ form.password1.id_for_label }}"
						name = "{{ form.password1.name }"
						placeholder="{{ form.password1.label }}"
						maxlength="20"
						required
						>
					</div>

					<div class="mb-3">
						<label for="password2" class="form-label">Confirm Password:</label>
						<input 
						type="password" 
						class="form-control" 
						id="{{ form.password2.id_for_label }}"
						name = "{{ form.password2.name }}"
						placeholder="{{ form.password2.label }}"
						maxlength="20"
						required
						>
					</div>

					<button type="submit" class="btn btn-primary text-center">Register</button>
				</form>
			</div>
		</div>
	</div>

{% endblock %}

todolist/templates/todoitem.html
{% extends "base.html" %}

{% block title %}My Tasks{% endblock %}

{% block content %}

	<div class = "text-center mt-3">
		<h1>{{task_name}}</h1>
		<h3>Description</h3>
		<p>{{description}}</p>
		<h3>Status:</h3>
		<p>{{status}}</p>

		<button class = "btn btn-success mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:update_task' id%}">Edit this task</a>
		</button>

		<button class = "btn btn-danger mx-1">
			<a class= "text-decoration-none" href = "{% url 'todolist:delete_task' id %}">Delete this task</a>
		</button>

		<button class = "btn btn-warning mx-1">
			<a class= "text-decoration-none"href = "{% url 'todolist:index' %}">Back to index page!</a>
		</button>

	</div>

{% endblock %}

todolist/templates/update_event.html
{% extends "base.html" %}

{% blick title %} Update Event {% endblock %}

{% block content %}
	{% if user.is_anonymous == False %}
		<div class="container">
			<div class="row">
				<div class="col-6 offset-3">
					<h1 class="text-center mt-3">Update Event</h1>

					{% if error == True%}
						<p>Event not found</p>
					{% endif%}
					<form action="{% url 'todolist:update_event' eventitem_id %}" method="post">

                        {% csrf_token %}

                        <div class="mb-3">
                            <label for="name">Task Name: </label>
                            <input class="form-control" id="event_name" type="text" name="name" value="{{ name }}" maxlength="50" required>
                        </div>

                        <div class="mb-3">
                            <label for="description">Description: </label>
                            <textarea class="form-control" name="description" required>{{ description }}</textarea>
                        </div>

                        <div class="mb-3">
                            <label for="status">Status: </label>
                            <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
                        </div>

                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Update Event">
                        </div>

                    </form>
				</div>
			</div>
		</div>
	{% endif %}

{% endblock %}

todolist/templates/update_task.html
{% extends "base.html" %}

{% blick title %} Update Task {% endblock %}

{% block content %}
	{% if user.is_anonymous == False %}
		<div class="container">
			<div class="row">
				<div class="col-6 offset-3">
					<h1 class="text-center mt-3">Update Task</h1>

					{% if error == True%}
						<p>Task not found</p>
					{% endif%}
					<form action="{% url 'todolist:update_task' todoitem_id %}" method="post">

                        {% csrf_token %}

                        <div class="mb-3">
                            <label for="task_name">Task Name: </label>
                            <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
                        </div>

                        <div class="mb-3">
                            <label for="description">Description: </label>
                            <textarea class="form-control" name="description" required>{{ description }}</textarea>
                        </div>

                        <div class="mb-3">
                            <label for="status">Status: </label>
                            <input class="form-control" id="status" type="text" name="status" value="{{ status }}" maxlength="50" required>
                        </div>

                        <div class="text-center">
                            <input class="btn btn-success" type="submit" value="Update Task">
                        </div>

                    </form>
				</div>
			</div>
		</div>
	{% endif %}

{% endblock %}